

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.23. grn_table_cursor &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.25.24. grn_thread_*" href="grn_thread.html" />
    <link rel="prev" title="7.25.22. grn_table" href="grn_table.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/api/grn_table_cursor.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="grn_thread.html" title="7.25.24. grn_thread_*"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="grn_table.html" title="7.25.22. grn_table"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.23. </span><code class="docutils literal notranslate"><span class="pre">grn_table_cursor</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-table-cursor">
<h1><span class="section-number">7.25.23. </span><code class="docutils literal notranslate"><span class="pre">grn_table_cursor</span></code><a class="headerlink" href="#grn-table-cursor" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.23.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>TODO...</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.23.2. </span>例<a class="headerlink" href="#example" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>TODO...</p>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.23.3. </span>リファレンス<a class="headerlink" href="#reference" title="このヘッドラインへのパーマリンク">¶</a></h2>
<dl class="c type">
<dt id="c.grn_table_cursor">
<em class="property">type </em><code class="sig-name descname">grn_table_cursor</code><a class="headerlink" href="#c.grn_table_cursor" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>TODO...</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_cursor_open">
<a class="reference internal" href="#c.grn_table_cursor" title="grn_table_cursor">grn_table_cursor</a> *<code class="sig-name descname">grn_table_cursor_open</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> void *<em>min</em>, unsigned int <em>min_size</em>, <em class="property">const</em> void *<em>max</em>, unsigned int <em>max_size</em>, int <em>offset</em>, int <em>limit</em>, int <em>flags</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_cursor_open" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>tableに登録されているレコードを順番に取り出すためのカーソルを生成して返します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> -- 対象tableを指定します。</p></li>
<li><p><strong>min</strong> -- keyの下限を指定します。（NULLは下限なしと見なします。） <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> については後述。</p></li>
<li><p><strong>min_size</strong> -- minのsizeを指定します。<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> については後述。</p></li>
<li><p><strong>max</strong> -- keyの上限を指定します。（NULLは上限なしと見なします。） <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> については後述。</p></li>
<li><p><strong>max_size</strong> -- maxのsizeを指定します。<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> については無視される場合があります。</p></li>
<li><p><strong>flags</strong> -- <p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_ASCENDING</span></code> を指定すると昇順にレコードを取り出します。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_DESCENDING</span></code> を指定すると降順にレコードを取り出します。(下記 <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> を指定し、keyが近いレコードを取得する場合、もしくは、common prefix searchを行う場合には、<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_ASCENDING</span></code> / <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_DESCENDING</span></code> は無視されます。)</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_GT</span></code> を指定するとminに一致したkeyをcursorの範囲に含みません。(minがNULLの場合もしくは、下記 <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> を指定し、keyが近いレコードを取得する場合、もしくは、common prefix searchを行う場合には、<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_GT</span></code> は無視されます。)</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_LT</span></code> を指定するとmaxに一致したkeyをcursorの範囲に含みません。(maxがNULLの場合もしくは、下記 <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> を指定した場合には、<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_LT</span></code> は無視されます。)</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_BY_ID</span></code> を指定するとID順にレコードを取り出します。(下記 <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> を指定した場合には、<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_BY_ID</span></code> は無視されます。) <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_PAT_KEY</span></code> を指定したtableについては、<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_BY_KEY</span></code> を指定するとkey順にレコードを取り出します。( <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_HASH_KEY</span></code> , <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_NO_KEY</span></code> を指定したテーブルでは <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_BY_KEY</span></code> は無視されます。)</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> を指定すると、 <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_PAT_KEY</span></code> を指定したテーブルに関する下記のレコードを取り出すカーソルが作成されます。maxがNULLの場合には、keyがminと前方一致するレコードを取り出します。max_sizeパラメータは無視されます。</p>
<p>maxとmax_sizeが指定され、かつ、テーブルのkeyがShortText型である場合、maxとcommon prefix searchを行い、common prefixがmin_sizeバイト以上のレコードを取り出します。minは無視されます。</p>
<p>maxとmax_sizeが指定され、かつ、テーブルのkeyが固定長型の場合、maxとPAT木上で近い位置にあるノードから順番にレコードを取り出します。ただし、keyのパトリシア木で、min_sizeバイト未満のビットに対するノードで、maxと異なった方向にあるノードに対応するレコードについては取り出しません。PAT木上で位置が近いこととkeyの値が近いことは同一ではありません。この場合、maxで与えられるポインタが指す値は、対象テーブルのkeyサイズと同じか超える幅である必要があります。minは無視されます。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_BY_ID</span></code> / <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_BY_KEY</span></code> / <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> の3フラグは、同時に指定することができません。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_PAT_KEY</span></code> を指定して作ったテーブルで、<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> と <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_RK</span></code> を指定すると、半角小文字のアルファベット文字列から、それを旧JIS X 4063:2000規格に従って全角カタカナに変換した文字列に前方一致する値をkeyとするレコードを取り出します。<code class="docutils literal notranslate"><span class="pre">GRN_ENC_UTF8</span></code> のみをサポートしています。<code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_ASCENDING</span></code> / <code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_DESCENDING</span></code> は無効であり、レコードをkey値の昇降順で取り出すことはできません。</p>
</p></li>
<li><p><strong>offset</strong> -- <p>該当する範囲のレコードのうち、(0ベースで)offset番目からレコードを取り出します。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> を指定したときは負の数を指定することはできません。</p>
</p></li>
<li><p><strong>limit</strong> -- <p>該当する範囲のレコードのうち、limit件のみを取り出します。-1が指定された場合は、全件が指定されたものとみなします。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CURSOR_PREFIX</span></code> を指定したときは-1より小さい負の数を指定することはできません。</p>
</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_cursor_close">
grn_rc <code class="sig-name descname">grn_table_cursor_close</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_table_cursor" title="grn_table_cursor">grn_table_cursor</a> *<em>tc</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_cursor_close" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p><a class="reference internal" href="#c.grn_table_cursor_open" title="grn_table_cursor_open"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_table_cursor_open()</span></code></a> で生成したcursorを解放します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>tc</strong> -- 対象cursorを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_cursor_next">
grn_id <code class="sig-name descname">grn_table_cursor_next</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_table_cursor" title="grn_table_cursor">grn_table_cursor</a> *<em>tc</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_cursor_next" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>cursorのカレントレコードを一件進めてそのIDを返します。cursorの対象範囲の末尾に達すると <code class="docutils literal notranslate"><span class="pre">GRN_ID_NIL</span></code> を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>tc</strong> -- 対象cursorを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_cursor_get_key">
int <code class="sig-name descname">grn_table_cursor_get_key</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_table_cursor" title="grn_table_cursor">grn_table_cursor</a> *<em>tc</em>, void **<em>key</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_cursor_get_key" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>cursorのカレントレコードのkeyをkeyパラメータにセットし、その長さを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>tc</strong> -- 対象cursorを指定します。</p></li>
<li><p><strong>key</strong> -- カレントレコードのkeyへのポインタがセットされます。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_cursor_get_value">
int <code class="sig-name descname">grn_table_cursor_get_value</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_table_cursor" title="grn_table_cursor">grn_table_cursor</a> *<em>tc</em>, void **<em>value</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_cursor_get_value" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>cursorパラメータのカレントレコードのvalueをvalueパラメータにセットし、その長さを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>tc</strong> -- 対象cursorを指定します。</p></li>
<li><p><strong>value</strong> -- カレントレコードのvalueへのポインタがセットされます。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_cursor_set_value">
grn_rc <code class="sig-name descname">grn_table_cursor_set_value</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_table_cursor" title="grn_table_cursor">grn_table_cursor</a> *<em>tc</em>, <em class="property">const</em> void *<em>value</em>, int <em>flags</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_cursor_set_value" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>cursorのカレントレコードのvalueを引数の内容に置き換えます。cursorのカレントレコードが存在しない場合は <code class="docutils literal notranslate"><span class="pre">GRN_INVALID_ARGUMENT</span></code> を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>tc</strong> -- 対象cursorを指定します。</p></li>
<li><p><strong>value</strong> -- 新しいvalueの値を指定します。</p></li>
<li><p><strong>flags</strong> -- <a class="reference internal" href="grn_obj.html#c.grn_obj_set_value" title="grn_obj_set_value"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_obj_set_value()</span></code></a> のflagsと同様の値を指定できます。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_cursor_delete">
grn_rc <code class="sig-name descname">grn_table_cursor_delete</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_table_cursor" title="grn_table_cursor">grn_table_cursor</a> *<em>tc</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_cursor_delete" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>cursorのカレントレコードを削除します。cursorのカレントレコードが存在しない場合は <code class="docutils literal notranslate"><span class="pre">GRN_INVALID_ARGUMENT</span></code> を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>tc</strong> -- 対象cursorを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_cursor_table">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_table_cursor_table</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_table_cursor" title="grn_table_cursor">grn_table_cursor</a> *<em>tc</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_cursor_table" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>cursorが属するtableを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>tc</strong> -- 対象cursorを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.23. <code class="docutils literal notranslate"><span class="pre">grn_table_cursor</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.23.1. 概要</a></li>
<li><a class="reference internal" href="#example">7.25.23.2. 例</a></li>
<li><a class="reference internal" href="#reference">7.25.23.3. リファレンス</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="grn_table.html"
                        title="前の章へ"><span class="section-number">7.25.22. </span><code class="docutils literal notranslate"><span class="pre">grn_table</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="grn_thread.html"
                        title="次の章へ"><span class="section-number">7.25.24. </span><code class="docutils literal notranslate"><span class="pre">grn_thread_*</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="grn_thread.html" title="7.25.24. grn_thread_*"
             >次へ</a> |</li>
        <li class="right" >
          <a href="grn_table.html" title="7.25.22. grn_table"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.23. </span><code class="docutils literal notranslate"><span class="pre">grn_table_cursor</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>